// LICENSE: MIT
"use strict";
/**
 * Log message entity.
 */
Object.defineProperty(exports, '__esModule', {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var LambdaLogsMessage =
/**
 * Initialize entity.
 * @params {String} text for lambda log. 
 */
function LambdaLogsMessage(message) {
  _classCallCheck(this, LambdaLogsMessage);

  if (/^START RequestId/.test(message)) {
    var match = message.match(/^START RequestId: (.*?)$/);
    this.type = 'start';
    this.message = message;
    this.text = message;
    this.requestId = match[1];
  } else if (/^END RequestId/.test(message)) {
    var match = message.match(/^END RequestId: (.*?)$/);
    this.type = 'end';
    this.message = message;
    this.text = message;
    this.requestId = match[1];
  } else if (/^REPORT RequestId/.test(message)) {
    var match = message.match(/^REPORT RequestId: (.*?)\tDuration: (.*?) ms\tBilled Duration: (.*?) ms \tMemory Size: (.*?) MB\tMax Memory Used: (.*?) MB$/);
    this.type = 'report';
    this.message = message;
    this.text = message;
    this.requestId = match[1];
    this.duration = parseFloat(match[2]);
    this.billedDulation = parseFloat(match[3]);
    this.memorySize = parseInt(match[4]);
    this.memoryUsed = parseInt(match[5]);
  } else {
    var match = message.match(/^(.*?)\t(.*?)\t([\s\S]*?)$/);
    if (!match) {
      this.message = message;
      this.text = message;
      return;
    }
    this.type = 'message';
    this.message = message;
    this.time = new Date(match[1]).getTime();
    this.requestId = match[2];
    this.text = match[3];
  }
};

exports['default'] = LambdaLogsMessage;
module.exports = exports['default'];