
"use strict";
// imports
Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _baconjs = require('baconjs');

var _baconjs2 = _interopRequireDefault(_baconjs);

// privates
var privateMap = new WeakMap();
function privates(self) {
  var p = privateMap.get(self);
  if (!p) {
    p = {};
    privateMap.set(self, p);
  }
  return p;
}
/**
 * To push the value to stream by schedule.
 * @class Scheduler
 */

var Scheduler = (function () {
  /**
   * Initialize Scheduler with interval and callback.
   * @param {Number} interval Interval to schedule
   & @param {Function} callback
   */

  function Scheduler(interval, callback) {
    _classCallCheck(this, Scheduler);

    privates(this).interval = interval;
    privates(this).callback = callback;
  }

  /**
   * Start pushing to the stream.
   * @return {Bacon.Bus} the stream
   */

  _createClass(Scheduler, [{
    key: "start",
    value: function start() {
      if (!!privates(this).interbalId) {
        this.stop();
      }

      var bus = new _baconjs2["default"].Bus();
      var callback = privates(this).callback;
      var index = 0;
      privates(this).interbalId = setInterval(function () {
        bus.push(callback(index++));
      }, privates(this).interval);

      return bus;
    }

    /**
     * Stop pushing to the stream.
     */
  }, {
    key: "stop",
    value: function stop() {
      if (!privates(this).interbalId) {
        return;
      }

      clearInterval(privates(this).interbalId);
    }
  }]);

  return Scheduler;
})();

exports["default"] = Scheduler;
module.exports = exports["default"];